<?php

if (!is_callable('sodiumCompatAutoloader')) {







function sodiumCompatAutoloader($class)
{
$namespace = 'ParagonIE_Sodium_';

 $len = strlen($namespace);
if (strncmp($namespace, $class, $len) !== 0) {

 return false;
}


 $relative_class = substr($class, $len);


 
 
 $file = dirname(__FILE__) . '/src/' . str_replace('_', '/', $relative_class) . '.php';

 if (file_exists($file)) {
require_once $file;
return true;
}
return false;
}


 spl_autoload_register('sodiumCompatAutoloader');
}

require_once dirname(__FILE__) . '/src/SodiumException.php';
if (PHP_VERSION_ID >= 50300) {

 
 require_once dirname(__FILE__) . '/lib/namespaced.php';
require_once dirname(__FILE__) . '/lib/sodium_compat.php';
}
if (PHP_VERSION_ID < 70200 || !extension_loaded('sodium')) {
require_once dirname(__FILE__) . '/lib/php72compat.php';
}
