<?php

namespace Katalysis;

require_once __DIR__ . '/http_client.php';
require_once __DIR__ . '/utility.php';
require_once __DIR__ . '/backend.php';

class HtmlRenderer
{
    public static function wallet_content_tail($post_signature) {
        return "<div class='katalysis-feather-tail' data-content-id='$post_signature'></div>";
    }

    public static function wallet_body(
        $type,
        $content_url, $content_id, $content_callback_url, $content_price,
        $origin_id,
        $features, $customization)
    {
        return "
<div class='katalysis-feather'
    data-plugin-type='$type'
    data-origin='$content_url' data-origin-id='$origin_id'
    data-content-id='$content_id' data-content-url='$content_callback_url'
    data-price='$content_price' data-currency='EUR'
    $customization $features>
</div>";
    }

    public static function wallet_page_html(
        $type,
        $origin_url, $origin_id,
        $features, $customization)
    {
        return "
<div class='katalysis-feather'
    data-plugin-type='$type'
    data-origin-id='$origin_id'
    $customization
    $features>
</div>";
    }
}